
//---------------------------------------------------------------------------

#include <vcl.h>
#include <math.h>
#pragma hdrstop

#include "Unit1.h"
#include "math.h"
#include "mpusbapi.h"                   // MPUSBAPI Header File

float k[] = { 0.023283064, 0.01862645, 0.01552212};
char gen = 0;

#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;




//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------


void __fastcall TForm1::FormCreate(TObject *Sender)
{
    BYTE send_buf[64],receive_buf[64];
    DWORD RecvLength=4;
    long frq;

    LoadDLL();

    //     DDS
    send_buf[0] = 0x02;      // Command  - READ EEPROM
    send_buf[1] = 0xC1;   //   

    SendReceivePacket(send_buf,2,receive_buf,&RecvLength,150,150);
    if(receive_buf[0] == 100 || receive_buf[0] == 80 || receive_buf[0] == 66){
        Label1->Caption = (int)receive_buf[0];
        if(receive_buf[0] == 80) gen = 1;
        if(receive_buf[0] == 66) gen = 2;
        Label1->Caption = Label1->Caption + " MHz";


        //    EEPROM 
        send_buf[1] = 0x51; //  
        SendReceivePacket(send_buf,2,receive_buf,&RecvLength,150,150);
        frq = receive_buf[0];
        send_buf[1] = 0x61; //  
        SendReceivePacket(send_buf,2,receive_buf,&RecvLength,150,150);
        frq += receive_buf[0] * 256;
        send_buf[1] = 0x71; //  
        SendReceivePacket(send_buf,2,receive_buf,&RecvLength,150,150);
        frq += receive_buf[0] * 65536;
        send_buf[1] = 0x81; //  
        SendReceivePacket(send_buf,2,receive_buf,&RecvLength,150,150);
        frq += receive_buf[0] * 16777216;

        Edit1->Text = ceil(frq * k[gen]);


    }else  Label1->Caption = " ";

}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button1Click(TObject *Sender)
{

    BYTE send_buf[64],receive_buf[64];
    DWORD RecvLength=4;

    int freq = StrToInt(Edit1->Text) / k[gen];
    int b1 = freq % 256;
    int b2 = freq / 256;
    int b3 = freq / 65536;
    int b4 = freq / 16777216;

    send_buf[0] = 0x01;      // Command
    send_buf[1] = b1;
    send_buf[2] = b2;
    send_buf[3] = b3;
    send_buf[4] = b4;
    SendReceivePacket(send_buf,5,receive_buf,&RecvLength,250,250);

    send_buf[0] = 0x03; //   EEPROM
    send_buf[1] = 0x51; //  1- 
    send_buf[2] = b1;
    SendReceivePacket(send_buf,3,receive_buf,&RecvLength,250,250);

    send_buf[1] = 0x61; //  2- 
    send_buf[2] = b2;
    SendReceivePacket(send_buf,3,receive_buf,&RecvLength,250,250);

    send_buf[1] = 0x71; //  3- 
    send_buf[2] = b3;
    SendReceivePacket(send_buf,3,receive_buf,&RecvLength,250,250);

    send_buf[1] = 0x81; //  4- 
    send_buf[2] = b4;
    SendReceivePacket(send_buf,3,receive_buf,&RecvLength,250,250);

}
//---------------------------------------------------------------------------







